/*Canopy - The next generation of stoner streaming software
Copyright (C) 2024-2025 Rainbownapkin and the TTN Community

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.*/

//NPM Imports
const {validationResult, matchedData} = require('express-validator');

//local imports
const channelModel = require('../../../schemas/channel/channelSchema');
const {exceptionHandler} = require('../../../utils/loggerUtils');

//get thumby
module.exports.get = async function(req, res){
    try{
        //Pull validated result
        const validResult = validationResult(req);

        //if everything validated proper
        if(validResult.isEmpty()){
            //Get matched data
            const data = matchedData(req);
            //pull channel
            const chanDB = await channelModel.findOne({name: data.chanName});

            //Null check channel
            if(chanDB == null){
                throw loggerUtils.exceptionSmith("Channel not found.", "validation");
            }

            //return thumby
            res.status(200);
            return res.send({thumbnail: chanDB.thumbnail});
        }else{
            res.status(400);
            res.send({errors: validResult.array()})
        }
    }catch(err){
        exceptionHandler(res, err);
    }
    
}

//Post function
module.exports.post = async function(req, res){
    try{
        //Pull validated result
        const validResult = validationResult(req);

        //if everything validated proper
        if(validResult.isEmpty()){
            //Get matched data
            const data = matchedData(req);
            //pull channel
            const chanDB = await channelModel.findOne({name: data.chanName});

            //Null check channel
            if(chanDB == null){
                throw loggerUtils.exceptionSmith("Channel not found.", "validation");
            }

            //Set thumbnail
            chanDB.thumbnail = data.thumbnail;

            //Save channel doc
            await chanDB.save();

            //return thumby
            res.status(200);
            return res.send({thumbnail: chanDB.thumbnail});
        }else{
            res.status(400);
            res.send({errors: validResult.array()})
        }
    }catch(err){
        exceptionHandler(res, err);
    }
    
}